clear all
close all

ele = ncread('GEBCO_2014_2D_-53.5_47.5_-51.0_49.1.nc','elevation');
lat = ncread('GEBCO_2014_2D_-53.5_47.5_-51.0_49.1.nc','lat');
lon = ncread('GEBCO_2014_2D_-53.5_47.5_-51.0_49.1.nc','lon'); 


%lon = lon([1:108,end],:); 
%lat = lat([1:150,end],:);
%ele = ele([1:108,end],[1:150,end]);
[LAT,LON] = meshgrid(lat,lon);

LatLoc = [48.6672,48.1719]';
LonLoc = [-53.1142,-52.9392]'; 

% Move all points at sea level to -1 to color them blue. 
% ele(ele<0) = -0.1;
% ele(ele>=0) = 0.1; 

% Compute the latitude and longitude limits for the DEM. 
latlim = [min(lat(:)) max(lat(:))];
lonlim = [min(lon(:)) max(lon(:))];

% Display the DEM values as a texture map. 
h = figure;
worldmap(latlim, lonlim)
h1 = plotm([47,48,49,50],[-54,-53,-52,-51],...
    'Marker','o','Color','w','LineStyle','none','MarkerSize',1);

% If you like a texture map with colors
geoshow(LAT, LON, ele, 'DisplayType','texturemap')
zlimits = [min(ele(:)),max(ele(:))]; 
demcmap('inc',zlimits,10)
colorbar

% If yo like only contour: Overlay black contour lines onto the texturemap.
geoshow(LAT, LON, ele, 'DisplayType', 'contour', ...
  'LineColor', 'black','linewidth',0.1);
demcmap(ele,2)
daspectm('m',1)


% geoshow(LAT, LON, ele, 'DisplayType', 'contour');
h5 = plotm(49,-51,'Marker','d','Color','k','LineStyle','none','MarkerSize',8,'MarkerFaceColor','k');
h2 = plotm(LatLoc,LonLoc,'Marker','s','Color','r','LineStyle','none','MarkerSize',8,'MarkerFaceColor','r'); 
h4 = plotm(47.5675,-52.7072,'Marker','o','Color','y','LineStyle','none','MarkerSize',8,'MarkerFaceColor','y'); 
% h3 = plotm(Iceberg1(:,2),Iceberg1(:,3),'Color','k','LineWidth',2);
% h6 = plotm(Iceberg2(:,2),Iceberg2(:,3),'Color','m','LineWidth',2);
% legend([h2 h5 h3 h6 h4],{'Weather Station','Weather Forecast','Iceberg1','Iceberg2','St John''s'},'Location','NorthEast')

% demcmap(ele,2)
% daspectm('m',1)

% Overlay black contour lines onto the texturemap.
% geoshow(LAT(1:3:end,1:3:end), LON(1:3:end,1:3:end), ele(1:3:end,1:3:end), 'DisplayType', 'contour', ...
%   'LineColor', 'black');