close all
clear all

%% Data import - tester med ret 2004

load dataWS04.mat
load dataCS04_0.mat
load dataCS04_10.mat
load dataCS04_20.mat
load dataCS04_30.mat
load dataCS04_40.mat
load dataCS04_50.mat
load dataCS04_60.mat
load dataCS04_70.mat
load dataCS04_80.mat
load dataCS04_90.mat
load dataCS04_100.mat
load dataCS04_150.mat

B = repelem(dataWS04,3,1); % fixing matrix dimension

%% Principal Component Analysis (PCA)

% med datasett hvor det er tatt data fra styrke p 0m, 50m og 100m
% (Ekman) over en tid p 6 uker (1000 vs 1008 punkter)

%% Time series
t = linspace(1,1000,1000)';
t2 = linspace(1,337,337)';

Xw10 = B(1:1000,:);
X0 = dataCS04_0(1:1000,:);
X10 = dataCS04_10(1:1000,:);
X20 = dataCS04_20(1:1000,:);
X30 = dataCS04_30(1:1000,:);
X40 = dataCS04_40(1:1000,:);
X50 = dataCS04_50(1:1000,:);
X60 = dataCS04_60(1:1000,:);
X70 = dataCS04_70(1:1000,:);
X80 = dataCS04_80(1:1000,:);
X90 = dataCS04_90(1:1000,:);
X100 = dataCS04_100(1:1000,:);
%X150 = dataCS04_150(1:1000,:);

%% Normalize

X = [Xw10*100 X0 X10 X20 X30 X40 X50 X60 X70 X80 X90 X100];  % data satt sammen

ma = max(X(:,1));

X = normalize(X,'range');
X = rescale(X,-1,1);

%%% max out of each row..
% X(:,1) = normalize(X(:,1),'range');
% X(:,1) = abs(X(:,1))-mean(abs(X(:,1)));
% %X(:,1) = rescale(X(:,1),-1,1);
% 
% for i = 1:12
%    X(:,i) = normalize(X(:,i),'range');
%    X(:,i) = abs(X(:,i))-mean(abs(X(:,i)));
%    %X(:,i) = rescale(X(:,i),-1,1);
% end
%%%

%%%
%scP = max(Xw10);
%B = B*100/scP; % scaling from m/s to cm/s and normalizing...
%%%

set(0, 'DefaultLineLineWidth', 1.5);
set(0, 'defaultTextFontSize',14)

figure % vind, 10m over vannet
set(gcf,'name','Time series of current strength year 2004');
clf;
subplot(2,1,1);
plot(t(1:500,:),X(1:500,1),t(1:500,:),X(1:500,2),t(1:500,:),X(1:500,3),t(1:500,:),...
    X(1:500,4),t(1:500,:),X(1:500,5),t(1:500,:),X(1:500,6),t(1:500,:),X(1:500,7),...
    t(1:500,:),X(1:500,8),t(1:500,:),X(1:500,9),t(1:500,:),X(1:500,10),t(1:500,:),...
    X(1:500,11),t(1:500,:),X(1:500,12));
grid on
legend('wind','surface','10m depth','20m depth','30m depth','40m depth','50m depth',...
    '60m depth','70m depth','80m depth','90m depth','100m depth')
xlabel('Time [hours]')
title('Time series of normalized current strength 2004')
subplot(2,1,2);
plot(t(500:1000,:),X(500:1000,1),t(500:1000,:),X(500:1000,2),t(500:1000,:),...
    X(500:1000,3),t(500:1000,:),X(500:1000,4),t(500:1000,:),X(500:1000,5),...
    t(500:1000,:),X(500:1000,6),t(500:1000,:),X(500:1000,7),t(500:1000,:),...
    X(500:1000,8),t(500:1000,:),X(500:1000,9),t(500:1000,:),X(500:1000,10),...
    t(500:1000,:),X(500:1000,11),t(500:1000,:),X(500:1000,12));
grid on
legend('wind','surface','10m depth','20m depth','30m depth','40m depth','50m depth',...
    '60m depth','70m depth','80m depth','90m depth','100m depth')
xlabel('Time [hours]')
%saveas(gcf,'timeseries_04_2.png') %lagre for hnd for  fikse legends!

%%%% for testing av normaliseringen
% figure
% plot(t(1:300,1),X(1:300,1),t(1:300,:),X(1:300,2));
% 
% figure
% plot(t,X(:,1),t,X(:,2));
%%%%

% figure % p 100m
% set(gcf,'name','Time series of strength 1993 100m depth');
% clf;
% subplot(3,1,1);
% plot(t,X100,'b');
% grid on
% subplot(3,1,2);
% plot(t(1:500,:),X100(1:500),'b');
% grid on
% subplot(3,1,3);
% plot(t(500:1000,:),X100(500:1000),'b');
% grid on


% skalering (forsk p...)

% mX = max(max(X))
% X = X./mX;

%% PCA analysis 

% mu = estimert mean for hver variabel i X)
% coeff: PC coeffs/loadings for X, descending order of variance cols
% score: each PC score
% latent: each PC variance
[coeff,score,latent,tsquared,explained,mu] = pca(X);   

%%
% eigenvectors and stuff
figure
vlbls = {'Wind','0m','10m','20m','30m','40m','50m','60m','70m','80m','90m','100m'};
biplot(coeff(:,1:3),'scores',score(:,1:3),'varlabels',vlbls); 
title('3D biplot of eigenvectors \lambda and principal component scores')
%saveas(gcf,'biplot_04_2.png') %lagret for hnd!!

%%
% scatter of PCs
figure
%scatter3(score(:,1),score(:,2),score(:,3)); %klarer ikke plotte mer enn 3dim
scatter3(coeff(:,1),coeff(:,2),coeff(:,3));
title('Principal component score')
axis equal
xlabel('PC1')
ylabel('PC2')
zlabel('PC3')
%saveas(gcf,'scatter_04_2.png')

%%
% prosent av tot var forklart av hver PC 
figure
plot(explained);
grid on
axis([1 12 0 100]);
title('Precentage of variance explained in each PC')
%saveas(gcf,'explained_04_2.png')


%%
% - % - % Endret for masteroppgave % - % - %
% degree of compression DoC
n = 1:12;
sizeNow = (n*100)/(length(n));
DoC = 100 - sizeNow;

% prosent av tot var forklart av hver PC an
figure
plot(1:length(n),cumsum(explained)); hold on;
plot(1:length(n),DoC)
title('Cumulative variance explained in each PC and degree of compression')
xlabel('number of PCs (rank)')
ylabel('%')
leg = legend('Total variance explained','Degree of compression','Location','best');
grid on
xticks([1 2 3 4 5 6 7 8 9 10 11 12])
leg.FontSize = 14;

%%



%%
% plotter score i de to frste PC mot hverandre - NEI, blir feil dimensjon,
% hva er det da? Hver PC score 1 og 2 - sjekk dim! Viser kanskje ikke s
% mye... Kanskje sjekke opp i dette i dokumentasjon? 
% ROWS: observations, COLS: components
figure
labels = {'PC1','PC2','PC3','PC4','PC5','PC6','PC7','PC8','PC9','PC10','PC11','PC12'}; % rett? Er PC1, PC2...
plot(score(1,:),score(2,:),'.','MarkerSize',15)
text(score(1,:),score(2,:),labels,'VerticalAlignment','bottom','HorizontalAlignment','right');
grid on
hold on
x=0; y=0;
plot(x,y,'k-');
xlabel('Score PC1')
ylabel('Score PC2')
%saveas(gcf,'scores_04_2.png')

%%
% plotter datasettene mot hverandre, jo sterker diagonal, jo strkere
% korrelasjon
figure
plot(X(:,1),X(:,2),'k.');
grid on
%axis([0 60 0 60])
%legend('wind and surface') % see a closer corr than wind and 50m
xlabel('Wind')
ylabel('Surface')
title('Correlation wind wrt surface')
%saveas(gcf,'corr12_04_2.png')

figure
plot(X(:,1),X(:,7),'b.');
grid on
%axis([0 60 0 60])
%legend('wind and 50m depth')
xlabel('Wind')
ylabel('50m')
title('Correlation wind wrt 50m depth')
%saveas(gcf,'corr13_04_2.png')

figure
plot(X(:,1),X(:,12),'m.');
grid on
%axis([0 60 0 60])
%legend('wind and 100m depth')
xlabel('Wind')
ylabel('100m')
title('Correlation wind wrt 100m depth')
%saveas(gcf,'corr14_04_2.png')


%% prver  rekonstruere med PC1 og PC2

% reconstruction = score*coeff'?
rec = score*coeff' + repmat(mu,1000,1);
error = sum((rec-X).^2);%error = sum((rec-X).^2);

approxRank1 = score(:,1)*coeff(:,1)'+repmat(mu,1000,1);
approxRank2 = score(:,1:2)*coeff(:,1:2)'+repmat(mu,1000,1);
approxRank3 = score(:,1:3)*coeff(:,1:3)'+repmat(mu,1000,1);
approxRank4 = score(:,1:4)*coeff(:,1:4)'+repmat(mu,1000,1);

% error with different ranks
errorR2 = sum((approxRank2-X).^2);
errorR3 = sum((approxRank3-X).^2);
errorR4 = sum((approxRank4-X).^2);

figure % reconstruction rank 2 pga variance explained
title('Reconstruction rank 1')
for k=1:12 
    subplot(4,3,k);
    hold on; grid on;
    plot(approxRank1(:,k),X(:,k),'mx');
    %plot(approxRank1(:,k),X(:,k),'rx');
    plot([-2 2],[-2 2],'b');
    xlim([-2 2]);
    xlim([-2 2]);
    a = -20+(10*k);
    if k == 1
        title('Wind')
    else
        title(['Current ' num2str(a) 'm depth']);
    end
end
%saveas(gcf,'reconstrR1_04_2.png')

figure % reconstruction rank 2 pga variance explained
title('Reconstruction rank 2')
for k=1:12 
    subplot(4,3,k);
    hold on; grid on;
    plot(approxRank2(:,k),X(:,k),'mx');
    %plot(approxRank1(:,k),X(:,k),'rx');
    plot([-2 2],[-2 2],'b');
    xlim([-2 2]);
    xlim([-2 2]);
    a = -20+(10*k);
    if k == 1
        title('Wind')
    else
        title(['Current ' num2str(a) 'm depth']);
    end
end
%saveas(gcf,'reconstrR2_04_2.png')

figure % reconstruction rank 3 for  se forskjellen
title('Reconstruction rank 3')
for k=1:12
    subplot(4,3,k);
    hold on; grid on;
    plot(approxRank3(:,k),X(:,k),'mx');
    %plot(approxRank2(:,k),X(:,k),'rx');
    plot([-2 2],[-2 2],'b');
    xlim([-2 2]);
    xlim([-2 2]);
    a = -20+(10*k);
    if k == 1
        title('Wind')
    else
        title(['Current ' num2str(a) 'm depth']);
    end
end
%saveas(gcf,'reconstrR3_04_2.png')

figure % reconstruction rank 3 for  se forskjellen
title('Reconstruction rank 4')
for k=1:12
    subplot(4,3,k);
    hold on; grid on;
    plot(approxRank4(:,k),X(:,k),'mx');
    %plot(approxRank2(:,k),X(:,k),'rx');
    plot([-2 2],[-2 2],'b');
    xlim([-2 2]);
    xlim([-2 2]);
    a = -20+(10*k);
    if k == 1
        title('Wind')
    else
        title(['Current ' num2str(a) 'm depth']);
    end
end
%saveas(gcf,'reconstrR4_04_2.png')
%%
errorX = [1 2 3 4 5 6 7 8 9 10 11 12];

figure
plot(errorX,errorR2,'r*-',errorX,errorR3,'g*-',errorX,errorR4,'m*-',errorX,error,'b*-')  % for hver kolonne
l = legend({'Rank 2','Rank 3','Rank 4','Rank 12'},'location','northeast') %'northwest' for ikke-squared
l = set(l,'FontSize',15)
xticks([1 2 3 4 5 6 7 8 9 10 11 12])
xticklabels({'wind','0m','10m','20m','30m','40m','50m','60m','70m','80m','90m','100m'})
xlabel('Variables')
ylabel('Error squared')
title('Error')
grid on
%saveas(gcf,'errorSq_04_2.png')

%%
figure
set(gcf,'name','Reconstructing time series rank 2')

subplot(2,1,1)
plot(t(1:500),rec(1:500,1:2),'linewidth',2)
hold on; grid on
plot(t(1:500),X(1:500,1:2))
legend('PC1-2 wind','PC1-2 current','TS wind','TS current')
xlabel('Time [hours]')
title('Reconstruction of timeseries, rank 2')

subplot(2,1,2)
plot(t(500:1000),rec(500:1000,1:2),'linewidth',2)
hold on; grid on
plot(t(500:1000),X(500:1000,1:2))
legend('PC1-2 wind','PC1-2 current','TS wind','TS current')
xlabel('Time [hours]')
saveas(gcf,'TSreconstrPC12_04_2.png')

% figure
% set(gcf,'name','Eigenvalues LAMBDA and eigenvectors RHO')
% clf;
% subplot(3,1,1);
% plot(LAMBDA,'o-');
% title('LAMBDA')
% grid on
% subplot(3,1,2);        % mangler dette av en eller annen grunn
% plot(RHO(:,1:2),'-')
% title('RHO 1,2')
% legend('1','2')
% grid on
% plot(RHO(:,3:4),'-')
% title('RHO 3,4')
% legend('3','4')
% grid on

% figure
% set(gcf, 'name','Reconstructed components RCs')
% clf;
% for m = 1:5;
%     subplot(5,1,m);
%     plot(t,RC(:,m),'r-');
%     ylabel(sprintf('RC %d',m));
%     ylim([-150 150]);
%     grid on
% end


% figure
% set(gcf,'name','Reconstructing the time series')
% subplot(2,1,1)
% plot(t(1:500),X(1:500,1))
% hold on
% plot(t(1:500),X(1:500,2))
% legend('PC1','PC2')

