clear all; clc; %close all;

load MM.mat 
load MMN10.mat 
load MME10.mat 
load MMS10.mat 
load MMW10.mat

%% Retter opp i retninger (hvor 180 garder er lagt til vind undvendig)
tmp1 = str2double(MM(:,2:3)); % middle pnt
[tmp1_th,tmp1_rho] = cart2pol(tmp1(:,1),tmp1(:,2));

tmp2 = str2double(MMN10(:,2:3)); % N10
[tmp2_th,tmp2_rho] = cart2pol(tmp2(:,1),tmp2(:,2));

tmp3 = str2double(MME10(:,2:3)); % E10
[tmp3_th,tmp3_rho] = cart2pol(tmp3(:,1),tmp3(:,2));

tmp4 = str2double(MMS10(:,2:3)); % S10
[tmp4_th,tmp4_rho] = cart2pol(tmp4(:,1),tmp4(:,2));

tmp5 = str2double(MMW10(:,2:3)); % W10
[tmp5_th,tmp5_rho] = cart2pol(tmp5(:,1),tmp5(:,2));


for n = 1:length(tmp1_th) % middle pnt
    tmp1_th(n,1) = tmp1_th(n,1) + 180;
    if tmp1_th(n,1) > 360
        tmp1_th(n,1) = tmp1_th(n,1) - 360;
    end
end
for n = 1:length(tmp2_th) % N10
    tmp2_th(n,1) = tmp2_th(n,1) + 180;
    if tmp2_th(n,1) > 360
        tmp2_th(n,1) = tmp2_th(n,1) - 360;
    end
end
for n = 1:length(tmp3_th) % E10
    tmp3_th(n,1) = tmp3_th(n,1) + 180;
    if tmp3_th(n,1) > 360
        tmp3_th(n,1) = tmp3_th(n,1) - 360;
    end
end
for n = 1:length(tmp4_th) % S10
    tmp4_th(n,1) = tmp4_th(n,1) + 180;
    if tmp4_th(n,1) > 360
        tmp4_th(n,1) = tmp4_th(n,1) - 360;
    end
end
for n = 1:length(tmp5_th) % W10
    tmp5_th(n,1) = tmp5_th(n,1) + 180;
    if tmp5_th(n,1) > 360
        tmp5_th(n,1) = tmp5_th(n,1) - 360;
    end
end

[MMx1,MMy1] = pol2cart(tmp1_th,tmp1_rho); % middle pnt
[MMx2,MMy2] = pol2cart(tmp2_th,tmp2_rho); % N10
[MMx3,MMy3] = pol2cart(tmp3_th,tmp3_rho); % E10
[MMx4,MMy4] = pol2cart(tmp4_th,tmp4_rho); % S10
[MMx5,MMy5] = pol2cart(tmp5_th,tmp5_rho); % W10

MMins1 = [MMx1,MMy1];
MM(:,2:3) = MMins1;
MMins2 = [MMx2,MMy2];
MMN10(:,2:3) = MMins2;
MMins3 = [MMx3,MMy3];
MME10(:,2:3) = MMins3;
MMins4 = [MMx4,MMy4];
MMS10(:,2:3) = MMins4;
MMins5 = [MMx5,MMy5];
MMW10(:,2:3) = MMins5;

%% CHOOSE DATES

% from = '08-Mar-1990 04:00:00'; % [dd-mm-yyyy hh:00:00] ex: '08-Mar-1990 04:00:00' (I: 1589) PS: (00->23h)
% to   = '10-Mar-1990 07:00:00'; % [dd-mm-yyyy hh:00:00]

% 2 r
% from = '08-Mar-1990 04:00:00'; % [dd-mm-yyyy hh:00:00] ex: '08-Mar-1990 04:00:00' (I: 1589) PS: (00->23h)
% to   = '08-Mar-1992 07:00:00'; % [dd-mm-yyyy hh:00:00]

% 5 r
% from = '08-Mar-1986 04:00:00'; % [dd-mm-yyyy hh:00:00] ex: '08-Mar-1990 04:00:00' (I: 1589) PS: (00->23h)
% to   = '08-Mar-1991 07:00:00'; % [dd-mm-yyyy hh:00:00]

% 10 r
from = '08-Mar-1985 04:00:00'; % [dd-mm-yyyy hh:00:00] ex: '08-Mar-1990 04:00:00' (I: 1589) PS: (00->23h)
to   = '08-Mar-1995 07:00:00'; % [dd-mm-yyyy hh:00:00]

% finding the index row for the specific to and from dates 
% LIK FOR ALLE!
IndexFrom = find(contains(MM,from));
IndexTo   = find(contains(MM,to));
rowF = IndexFrom;
rowT = IndexTo;


% TRAINING DATASET

a1 = 2:3;    %wind
a2 = 4:5;    %0m
a3 = 6:7;    %10m
a4 = 8:9;    %20m
a5 = 10:11;  %30m
a6 = 12:13;  %40m
a7 = 14:15;  %50m
a8 = 16:17;  %60m
a9 = 18:19;  %70m
a10 = 20:21; %80m
a11 = 22:23; %90m
a12 = 24:25; %100m
a13 = 26:27; %125m
a14 = 28:29; %150m
a15 = 30:31; %175m
a16 = 32:33; %200m
a17 = 34:35; %250m
a18 = 36:37; %300m

f1 = rowF:rowT;
f2 = rowF-1:rowT-1;
f3 = rowF-2:rowT-2;
f4 = rowF-3:rowT-3;
f5 = rowF-4:rowT-4;
f6 = rowF-5:rowT-5;
f7 = rowF-6:rowT-6;
f8 = rowF-7:rowT-7;


%%
% velger her hvor mye/hvilken data som skal vre med
f = {f1 f2 f3 f4 f5 f6 f7 f8};
a = {a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18};
% a = {a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18};
%    wind 0  10 20 30 40 50 60 70 80  90  100 125 150 175 200 250 300


%% t = X-elementer for 0-punkt
vars = 2*length(a);

t = cell(1,length(f));
tIgjen = zeros(length(f1),2*length(a));
for j = 1:length(f)
    tn0_try = zeros(length(f1),length(a));
    tn0_try(:,1:2) = MM(f{j},a{1});
    for i = 2:length(a)
        tn0_try(:,2*i-1:2*i) = MM(f{j},a{i});
    end
    tn0_try = num2cell(tn0_try);
    t{j} = tn0_try(:,:);
    %tIgjen(:,(j-1)*vars+1:j*vars) = [t{j}]; %
    %tIgjen(:,j) = str2double(t{j});
end

tIgjen = [ t{1} t{2} t{3} t{4} t{5} t{6} t{7} t{8} ];
tIgjen = cell2mat(tIgjen);


%% tN10 = X-elementer for N10 punkt
tN10 = cell(1,length(f));
for j = 1:length(f)
    tn0_try = zeros(length(f1),length(a));
    tn0_try(:,1:2) = MMN10(f{j},a{1});
    for i = 2:length(a)
        tn0_try(:,2*i-1:2*i) = MMN10(f{j},a{i});
    end
    tn0_try = num2cell(tn0_try);
    tN10{j} = tn0_try(:,:);
end

tN10Igjen = [ tN10{1} tN10{2} tN10{3} tN10{4} tN10{5} tN10{6} tN10{7} tN10{8} ];
tN10Igjen = cell2mat(tN10Igjen);

%% tE10 = X-elementer for E10 punkt
tE10 = cell(1,length(f));
for j = 1:length(f)
    tn0_try = zeros(length(f1),length(a));
    tn0_try(:,1:2) = MME10(f{j},a{1});
    for i = 2:length(a)
        tn0_try(:,2*i-1:2*i) = MME10(f{j},a{i});
    end
    tn0_try = num2cell(tn0_try);
    tE10{j} = tn0_try(:,:);
end

tE10Igjen = [ tE10{1} tE10{2} tE10{3} tE10{4} tE10{5} tE10{6} tE10{7} tE10{8} ];
tE10Igjen = cell2mat(tE10Igjen);

%% tS10 = X-elementer for S10 punkt
tS10 = cell(1,length(f));
for j = 1:length(f)
    tn0_try = zeros(length(f1),length(a));
    tn0_try(:,1:2) = MMS10(f{j},a{1});
    for i = 2:length(a)
        tn0_try(:,2*i-1:2*i) = MMS10(f{j},a{i});
    end
    tn0_try = num2cell(tn0_try);
    tS10{j} = tn0_try(:,:);
end

tS10Igjen = [ tS10{1} tS10{2} tS10{3} tS10{4} tS10{5} tS10{6} tS10{7} tS10{8} ];
tS10Igjen = cell2mat(tS10Igjen);

%% tW10 = X-elementer for W10 punkt
tW10 = cell(1,length(f));
for j = 1:length(f)
    tn0_try = zeros(length(f1),length(a));
    tn0_try(:,1:2) = MMW10(f{j},a{1});
    for i = 2:length(a)
        tn0_try(:,2*i-1:2*i) = MMW10(f{j},a{i});
    end
    tn0_try = num2cell(tn0_try);
    tW10{j} = tn0_try(:,:);
end

tW10Igjen = [ tW10{1} tW10{2} tW10{3} tW10{4} tW10{5} tW10{6} tW10{7} tW10{8} ];
tW10Igjen = cell2mat(tW10Igjen);

% PUTTING TOGETHER TO X MATRIX
X = [tIgjen tN10Igjen tE10Igjen tS10Igjen tW10Igjen];

% RESPONSE IS WHAT HAPPENS RIGHT AFTER TRAINING..
diffFT = rowT - rowF;
g1 = (rowT+1):(rowT+diffFT+1);

% SETTING UP Y MATRIX AND WANT TO SET UP MUCH LESS RESPONSE THAN TRAIN

% OBS! Pass p tidsaspektet! rett etter dersom vil forecaste, samtidig for  relatere!
% t1 = [ MM(f1,a1) MM(f1,a2)  MM(f1,a3)  MM(f1,a4)  MM(f1,a5)  MM(f1,a6)  MM(f1,a7)  MM(f1,a8) ]; % tn FULL
t1 = [ MM(f1,a1) MM(f1,a2) MM(f1,a3) MM(f1,a4) MM(f1,a5)  MM(f1,a6)  MM(f1,a7)  MM(f1,a8)  MM(f1,a9)  MM(f1,a10)  MM(f1,a11) MM(f1,a12) MM(f1,a13) MM(f1,a14) MM(f1,a15) MM(f1,a16) MM(f1,a17) MM(f1,a18) ]; % tn FULL

Y = [ t1 ]; % response matrix
Y = str2double(Y);


%%

% TESTING DATASET
% (MAKING TEST SET THE DATA RIGHT AFTER RESPONSE SET - MAYBE A YEAR BETTER?)

h1 = g1+1;
h2 = h1-1;
h3 = h2-2;
h4 = h3-3;
h5 = h4-4;
h6 = h5-5;
h7 = h6-6;
h8 = h7-7;

h = {h1 h2 h3 h4 h5 h6 h7 h8};

% SETTING UP X-MATRICES FOR TESTING DATASET

tT0 = cell(1,length(h));
for j = 1:length(h)
    tnT0_try = zeros(length(h1),length(a));
    tnT0_try(:,1:2) = MM(h{j},a{1});
    for i = 2:length(a)
        tnT0_try(:,2*i-1:2*i) = MM(h{j},a{i});
    end
    tnT0_try = num2cell(tnT0_try);
    tT0{j} = tnT0_try(:,:);
end

tT0Igjen = [ tT0{1} tT0{2} tT0{3} tT0{4} tT0{5} tT0{6} tT0{7} tT0{8} ];
tT0Igjen = cell2mat(tT0Igjen);

tTN10 = cell(1,length(h));
for j = 1:length(h)
    tnTN10_try = zeros(length(h1),length(a));
    tnTN10_try(:,1:2) = MMN10(h{j},a{1});
    for i = 2:length(a)
        tnTN10_try(:,2*i-1:2*i) = MMN10(h{j},a{i});
    end
    tnTN10_try = num2cell(tnTN10_try);
    tTN10{j} = tnTN10_try(:,:);
end

tTN10Igjen = [ tTN10{1} tTN10{2} tTN10{3} tTN10{4} tTN10{5} tTN10{6} tTN10{7} tTN10{8} ];
tTN10Igjen = cell2mat(tTN10Igjen);

tTE10 = cell(1,length(h));
for j = 1:length(h)
    tnTE10_try = zeros(length(h1),length(a));
    tnTE10_try(:,1:2) = MME10(h{j},a{1});
    for i = 2:length(a)
        tnTE10_try(:,2*i-1:2*i) = MME10(h{j},a{i});
    end
    tnTE10_try = num2cell(tnTE10_try);
    tTE10{j} = tnTE10_try(:,:);
end

tTE10Igjen = [ tTE10{1} tTE10{2} tTE10{3} tTE10{4} tTE10{5} tTE10{6} tTE10{7} tTE10{8} ];
tTE10Igjen = cell2mat(tTE10Igjen);

tTS10 = cell(1,length(h));
for j = 1:length(h)
    tnTS10_try = zeros(length(h1),length(a));
    tnTS10_try(:,1:2) = MMS10(h{j},a{1});
    for i = 2:length(a)
        tnTS10_try(:,2*i-1:2*i) = MMS10(h{j},a{i});
    end
    tnTS10_try = num2cell(tnTS10_try);
    tTS10{j} = tnTS10_try(:,:);
end

tTS10Igjen = [ tTS10{1} tTS10{2} tTS10{3} tTS10{4} tTS10{5} tTS10{6} tTS10{7} tTS10{8} ];
tTS10Igjen = cell2mat(tTS10Igjen);

tTW10 = cell(1,length(h));
for j = 1:length(h)
    tnTW10_try = zeros(length(h1),length(a));
    tnTW10_try(:,1:2) = MMW10(h{j},a{1});
    for i = 2:length(a)
        tnTW10_try(:,2*i-1:2*i) = MMW10(h{j},a{i});
    end
    tnTW10_try = num2cell(tnTW10_try);
    tTW10{j} = tnTW10_try(:,:);
end

tTW10Igjen = [ tTW10{1} tTW10{2} tTW10{3} tTW10{4} tTW10{5} tTW10{6} tTW10{7} tTW10{8} ];
tTW10Igjen = cell2mat(tTW10Igjen);


% PUTTING TOGETHER TO X MATRIX
X2 = [tT0Igjen tTN10Igjen tTE10Igjen tTS10Igjen tTW10Igjen];

% X2 = [ tn_2 tn1_2 tn2_2 tn3_2 tn4_2 tn5_2 tn6_2 tn7_2 ]; % predictor matrix
% X2 = str2double(X2);

diffFT = rowT - rowF;
g1 = (rowT+1):(rowT+diffFT+1);


% t1 = [ MM(f1,a1) MM(f1,a2)  MM(f1,a3)  MM(f1,a4)  MM(f1,a5)  MM(f1,a6)  MM(f1,a7)  MM(f1,a8) ]; % tn FULL

%        100m xy  -  125 xy  -  150 xy  -  175 xy  -  200 xy  -  250 xy  -  300 xy
t1_2 = [ MM(h1,a1) MM(h1,a2) MM(h1,a3) MM(h1,a4) MM(h1,a5)  MM(h1,a6)  MM(h1,a7)  MM(h1,a8) MM(h1,a9)  MM(h1,a10)  MM(h1,a11) MM(h1,a12)  MM(h1,a13)  MM(h1,a14) MM(h1,a15)  MM(h1,a16)  MM(h1,a17) MM(h1,a18) ]; % tn FULL

Y2 = [ t1_2 ]; % response matrix
Y2 = str2double(Y2);
%%

% load('X2_2y.mat')
% load('X_2y.mat')
% load('Y2_2y.mat')
% load('Y_2y.mat')

load('X2_5y.mat')
load('X_5y.mat')
load('Y2_5y.mat')
load('Y_5y.mat')

%% PLSR analysis

% PARTIAL LEAST SQUARES REGRESSION

ncomp = 5; % 4 5 18 32
time  = linspace(1,1000,1000);
components = 1:16;

% TRAINING THE ALGORITHM
[XL,YL,XS,YS,BETA,PCTvar,MSE,stats] = plsregress(X,Y,ncomp);

[n,p] = size(X);

yFit_train = [ones(n,1) X]*BETA; 

diff_train = Y - yFit_train; % blir residuals..?


% TESTING THE BETA on test set
[~,widthX2] = size(X2); %s lenge det er de frste elementene!! (og X/X2 ikke er like store)
yFit_test = [ones(n,1) X2]*BETA(1:(widthX2+1),:);


%% UN-NORMALIZE (AND UN-SCALE) THE DATA...

load strdDevC.mat
load strdDevW.mat

% strength ganges med standard deviation
strdDevCcart = repelem(strdDevC,1,2);
strdDevWcart = repelem(strdDevW,1,2);

strdDevcart = [ strdDevWcart strdDevCcart ];
strdDevpol  = [ strdDevW strdDevC ];

yFit_train2 = yFit_train.*strdDevcart;
yFit_train = yFit_train2;

yFit_test2 = yFit_test.*strdDevcart;
yFit_test = yFit_test2;

Y_try = Y.*strdDevcart;
Y = Y_try;

Y_try2 = Y2.*strdDevcart;
Y2 = Y_try2;







%% RECONTRUCTING yFit INTO TIMESERIES TO SEE DIFFERNCE IN CURRENT (cart to pol!)

% PLOTTING X AND Y SEPARATED
yFit_x_train = yFit_train(:,1:2:end);
yFit_y_train = yFit_train(:,2:2:end);
Y_x = Y(:,1:2:end);
Y_y = Y(:,2:2:end);

yFit_x_test = yFit_test(:,1:2:end);
yFit_y_test = yFit_test(:,2:2:end);
Y2_x = Y2(:,1:2:end);
Y2_y = Y2(:,2:2:end);

% back to polar coordinates from cartesian
% TH: (wind/current) direction, 
%  R: (wind/current) strength

[TH_train,R_train] = cart2pol(Y_x,Y_y);
[TH_trainFit,R_trainFit] = cart2pol(yFit_x_train,yFit_y_train);
[TH_test,R_test] = cart2pol(Y2_x,Y2_y);
[TH_testFit,R_testFit] = cart2pol(yFit_x_test,yFit_y_test);

%% plotting
set(0,'defaultAxesFontSize',14)
set(0,'DefaultLineLineWidth',1.5);
set(0,'DefaultAxesXGrid','on','DefaultAxesYGrid','on');
set(0,'DefaultLineMarkerSize',8);
% set(0,'DefaultAxesMarkerSize',8);


%[rowY,colY] = size(Y);
colY = 36;




%% Error etter fix... alts uten treningsdata-error

% load error MAT-filer frst!

figure
subplot(2,1,1)
% plot(1:(colY/2-1),error_te2P(3:2:end),'.-'); hold on;
% plot(1:(colY/2-1),error_te5P(3:2:end),'.-'); hold on;
% plot(1:(colY/2-1),error_te10P(3:2:end),'.-');
plot(1:(colY/2-1),error_te2P5nc(3:2:end),'.-'); hold on;
plot(1:(colY/2-1),error_te5P5nc(3:2:end),'.-'); hold on;
plot(1:(colY/2-1),error_te10P5nc(3:2:end),'.-');
l = legend('2years','5years','10years','Location','N');
l = set(l,'FontSize',15);
title('MSE of x-velocities for test sets rank 5')
xticks([1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17])
xticklabels({'0m','10m','20m','30m','40m','50m','60m','70m',...
    '80m','90m','100m','125m','150m','175m','200m','250m','300m'})
xlabel('Forecasted variables')
ylabel('Mean squared sum error')
axis([0 17 0 1])

subplot(2,1,2)
% plot(1:(colY/2-1),error_te2P(4:2:end),'.-'); hold on;
% plot(1:(colY/2-1),error_te5P(4:2:end),'.-'); hold on;
% plot(1:(colY/2-1),error_te10P(4:2:end),'.-');
plot(1:(colY/2-1),error_te2P5nc(4:2:end),'.-'); hold on;
plot(1:(colY/2-1),error_te5P5nc(4:2:end),'.-'); hold on;
plot(1:(colY/2-1),error_te10P5nc(4:2:end),'.-');
title('MSE of y-velocities for test set rank 5')
xticks([1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17])
xticklabels({'0m','10m','20m','30m','40m','50m','60m','70m',...
    '80m','90m','100m','125m','150m','175m','200m','250m','300m'})
xlabel('Forecasted variables')
ylabel('Mean squared sum error')
axis([0 17 0 1])


%%
% strength
time2 = linspace(1,n,n);
omr = 1:100;%1201:1300;%5001:5200;%8000:8500;
% Samme som for 1000pnts PLSR og GPR
% plot(time2(omr),R_test(omr,13:14),'b',time2(omr),R_testFit(omr,13:14),'m')

figure
subplot(5,1,1)
% plot(omr,R_test(omr,2),'b--',omr,R_testFit(omr,2),'b',omr,R_test(omr,1),'r--',omr,R_testFit(omr,1),'r');
plot(omr,Y2_y(omr,2),'b--',omr,yFit_y_test(omr,2),'b',omr,Y2_x(omr,2),'g--',omr,yFit_x_test(omr,2),'g');
title('x- and y-velocity at 0m estimated and real')
l = legend('y-vel real','y-vel est','x-vel real','x-vel est');
l = set(l,'FontSize',15);
xlabel('Time [h]')
ylabel('C_s [cm/s]')

subplot(5,1,2)
plot(omr,Y2_y(omr,6),'b--',omr,yFit_y_test(omr,6),'b',omr,Y2_x(omr,6),'g--',omr,yFit_x_test(omr,6),'g');
title('x- and y-velocity at 40m estimated and real')
xlabel('Time [h]')
ylabel('C_s [cm/s]')

subplot(5,1,3)
plot(omr,Y2_y(omr,10),'b--',omr,yFit_y_test(omr,10),'b',omr,Y2_x(omr,10),'g--',omr,yFit_x_test(omr,10),'g');
title('x- and y-velocity at 80m estimated and real')
xlabel('Time [h]')
ylabel('C_s [cm/s]')

subplot(5,1,4)
plot(omr,Y2_y(omr,14),'b--',omr,yFit_y_test(omr,14),'b',omr,Y2_x(omr,14),'g--',omr,yFit_x_test(omr,14),'g');
title('x- and y-velocity at 150m estimated and real')
xlabel('Time [h]')
ylabel('C_s [cm/s]')

subplot(5,1,5)
plot(omr,Y2_y(omr,18),'b--',omr,yFit_y_test(omr,18),'b',omr,Y2_x(omr,18),'g--',omr,yFit_x_test(omr,18),'g');
title('x- and y-velocity at 300m estimated and real')
xlabel('Time [h]')
ylabel('C_s [cm/s]')
