% clear all; %close all; clc

% LOADING MAT FILES
% (column one is wind)

% load Xd.mat
% load X_dE10.mat
% load X_dN10.mat
% load X_dS10.mat
% load X_dW10.mat
% 
% load Xs.mat
% load X_sE10.mat
% load X_sN10.mat
% load X_sS10.mat
% load X_sW10.mat
% 
% 
% % DECOMPOSE VELOCITY AND DIRECTION TO x-vel AND y-vel IN THE GRID
% deg2rad = pi/180;
% 
% % origo
% Xd = Xd*deg2rad;
% [xvel,yvel] = pol2cart(Xd,Xs);
% 
% % N
% X_dN10 = X_dN10*deg2rad;
% [xvelN10,yvelN10] = pol2cart(X_dN10,X_sN10);
% 
% % E
% X_dN10 = X_dN10*deg2rad;
% [xvelE10,yvelE10] = pol2cart(X_dE10,X_sE10);
% 
% % S
% X_dN10 = X_dN10*deg2rad;
% [xvelS10,yvelS10] = pol2cart(X_dS10,X_sS10);
% 
% % W
% X_dN10 = X_dN10*deg2rad;
% [xvelW10,yvelW10] = pol2cart(X_dW10,X_sW10);

%% Loading MM-files

load MM.mat
load MMN10.mat
load MME10.mat
load MMS10.mat
load MMW10.mat


%% Retter opp i retninger (hvor 180 garder er lagt til vind undvendig)
tmp1 = str2double(MM(:,2:3)); % middle pnt
[tmp1_th,tmp1_rho] = cart2pol(tmp1(:,1),tmp1(:,2));

tmp2 = str2double(MMN10(:,2:3)); % N10
[tmp2_th,tmp2_rho] = cart2pol(tmp2(:,1),tmp2(:,2));

tmp3 = str2double(MME10(:,2:3)); % E10
[tmp3_th,tmp3_rho] = cart2pol(tmp3(:,1),tmp3(:,2));

tmp4 = str2double(MMS10(:,2:3)); % S10
[tmp4_th,tmp4_rho] = cart2pol(tmp4(:,1),tmp4(:,2));

tmp5 = str2double(MMW10(:,2:3)); % W10
[tmp5_th,tmp5_rho] = cart2pol(tmp5(:,1),tmp5(:,2));


for n = 1:length(tmp1_th) % middle pnt
    tmp1_th(n,1) = tmp1_th(n,1) + 180;
    if tmp1_th(n,1) > 360
        tmp1_th(n,1) = tmp1_th(n,1) - 360;
    end
end
for n = 1:length(tmp2_th) % N10
    tmp2_th(n,1) = tmp2_th(n,1) + 180;
    if tmp2_th(n,1) > 360
        tmp2_th(n,1) = tmp2_th(n,1) - 360;
    end
end
for n = 1:length(tmp3_th) % E10
    tmp3_th(n,1) = tmp3_th(n,1) + 180;
    if tmp3_th(n,1) > 360
        tmp3_th(n,1) = tmp3_th(n,1) - 360;
    end
end
for n = 1:length(tmp4_th) % S10
    tmp4_th(n,1) = tmp4_th(n,1) + 180;
    if tmp4_th(n,1) > 360
        tmp4_th(n,1) = tmp4_th(n,1) - 360;
    end
end
for n = 1:length(tmp5_th) % W10
    tmp5_th(n,1) = tmp5_th(n,1) + 180;
    if tmp5_th(n,1) > 360
        tmp5_th(n,1) = tmp5_th(n,1) - 360;
    end
end

[MMx1,MMy1] = pol2cart(tmp1_th,tmp1_rho); % middle pnt
[MMx2,MMy2] = pol2cart(tmp2_th,tmp2_rho); % N10
[MMx3,MMy3] = pol2cart(tmp3_th,tmp3_rho); % E10
[MMx4,MMy4] = pol2cart(tmp4_th,tmp4_rho); % S10
[MMx5,MMy5] = pol2cart(tmp5_th,tmp5_rho); % W10

MMins1 = [MMx1,MMy1];
MM(:,2:3) = MMins1;
MMins2 = [MMx2,MMy2];
MMN10(:,2:3) = MMins2;
MMins3 = [MMx3,MMy3];
MME10(:,2:3) = MMins3;
MMins4 = [MMx4,MMy4];
MMS10(:,2:3) = MMins4;
MMins5 = [MMx5,MMy5];
MMW10(:,2:3) = MMins5;

% FINNER INDEX
% 2 r
from = '08-Mar-1990 04:00:00'; % [dd-mm-yyyy hh:00:00] ex: '08-Mar-1990 04:00:00' (I: 1589) PS: (00->23h)
to   = '08-Mar-1992 07:00:00'; % [dd-mm-yyyy hh:00:00]

% 5 r
% from = '08-Mar-1986 04:00:00'; % [dd-mm-yyyy hh:00:00] ex: '08-Mar-1990 04:00:00' (I: 1589) PS: (00->23h)
% to   = '08-Mar-1991 07:00:00'; % [dd-mm-yyyy hh:00:00]

% 10 r
% from = '08-Mar-1985 04:00:00'; % [dd-mm-yyyy hh:00:00] ex: '08-Mar-1990 04:00:00' (I: 1589) PS: (00->23h)
% to   = '08-Mar-1995 07:00:00'; % [dd-mm-yyyy hh:00:00]

% finding the index row for the specific to and from dates 
% LIK FOR ALLE!
IndexFrom = find(contains(MM,from));
IndexTo   = find(contains(MM,to));
rowF = IndexFrom;
rowT = IndexTo;


%% gjr om til polare koordinater
[preTh,preRho] = cart2pol( str2double( MM(:,2:2:end) ),str2double( MM(:,3:2:end) ) );

[preThN10,preRhoN10] = cart2pol( str2double( MMN10(:,2:2:end) ),str2double( MMN10(:,3:2:end) ) );
[preThE10,preRhoE10] = cart2pol( str2double( MME10(:,2:2:end) ),str2double( MME10(:,3:2:end) ) );
[preThS10,preRhoS10] = cart2pol( str2double( MMS10(:,2:2:end) ),str2double( MMS10(:,3:2:end) ) );
[preThW10,preRhoW10] = cart2pol( str2double( MMW10(:,2:2:end) ),str2double( MMW10(:,3:2:end) ) );


% FOR NORMAL ANALYSIS
X_depth = preRho;
X_direc = preTh;


% FOR HORIZONTAL ANALYSIS
b = 16; % constant depth (2=0m, 16=200m)
X_depthSH = [ preTh(rowF:rowT,b) preThN10(rowF:rowT,b) preThE10(rowF:rowT,b) preThS10(rowF:rowT,b) preThW10(rowF:rowT,b) ];
X_depthDH = [ preTh(rowF:rowT,b) preThN10(rowF:rowT,b) preThE10(rowF:rowT,b) preThS10(rowF:rowT,b) preThW10(rowF:rowT,b) ];


%% UN-NORMALIZE (AND UN-SCALE) THE DATA...

load strdDevC.mat
load strdDevW.mat

% strength ganges med standard deviation
strdDevCcart = repelem(strdDevC,1,2);
strdDevWcart = repelem(strdDevW,1,2);

strdDevcart = [ strdDevWcart strdDevCcart ];
strdDevpol  = [ strdDevW strdDevC ];

preRho1 = preRho.*strdDevpol;
preRho = preRho1;


%% ANALYSIS OF WIND AND DEEPER CURRENTS

% PLOTTE DELER AV STRMMEN 
% 1000 points = 6 uker

% X_deep0 = [preRho(1:1000,1) preRho(1:1000,14:18)]; % wind 150 175 200 250 300
% 
% figure
% subplot(2,1,1)
% s1 = scatter3(X_deep0(:,1),X_deep0(:,4),X_deep0(:,6)); hold on;
% s2 = scatter3(X_deep0(:,1),preRho(1:1000,2),preRho(1:1000,3));
% %axis([0 1 0 .05 0 .05])
% xlabel('wind')
% ylabel('Cs at 0m and 200m')
% zlabel('Cs at 10m and 300m')
% title('Difference in Cs for upper and deep current in relation to wind')
% legend([s1 s2],{'deep current','upper current'},'Location','Best')
% % somewhat strong corr when high current strength in both 200 and 300, the
% % wind is strong. Correspondingly, weak wind when weaker deep current.
% % Upper current is generally stronger.
% area = linspace(1,1000,1000);
% %figure 
% subplot(2,1,2)
% plot(area,X_deep0(:,1),area,preRho(1:1000,2),area,preRho(1:1000,3),area,X_deep0(:,4),area,X_deep0(:,6),'LineWidth',1.5);
% legend('wind','0m','10m','200m','300m','Location','Best')
% xlabel('time')
% ylabel('Cs')
% title('Current strength in the different layers')
% grid on;

%%
% X_deep0_dir = [preTh(1:1000,1) XpreTh(1:1000,14:18)]; % wind 150 175 200 250 300
% 
% figure
% polarhistogram(X_deep0_dir(:,1),12,'DisplayStyle','stairs');


% scatter3(X_deep0_dir(:,1),X_deep0_dir(:,4),X_deep0_dir(:,6));
% xlabel('wind')
% ylabel('200')
% zlabel('300')


%% plot with wind, 200m and 175m/300m
% 
% X_deep0 = [Xs(1:1000,1) Xs(1:1000,14:18)]; % wind 150 175 200 250 300
% 
% figure
% scPlot1 = scatter3(X_deep0(:,1),X_deep0(:,4),X_deep0(:,6)); hold on;
% scPlot2 = scatter3(X_deep0(:,1),X_deep0(:,4),X_deep0(:,2));
% axis([0 1 0 .05 0 .05])
% xlabel('wind')
% ylabel('200')
% zlabel('300 and 150')
% legend([scPlot1 scPlot2],'wind, 200 and 300m','wind, 200 and 150m')
% 
% 
% 
% X_deep0_dir = [Xd(1:1000,1) Xd(1:1000,14:18)]; % wind 150 175 200 250 300
% 
% figure
% scPlot3 = scatter3(X_deep0_dir(:,1),X_deep0_dir(:,4),X_deep0_dir(:,6)); hold on;
% scPlot4 = scatter3(X_deep0_dir(:,1),X_deep0_dir(:,4),X_deep0_dir(:,2));
% axis([0 0.15 0 0.15 0 0.15])
% xlabel('wind')
% ylabel('200')
% zlabel('300 and 150')
% legend([scPlot3 scPlot4],'wind, 200 and 300m','wind, 200 and 150m')
% 
% hold off;

%%
% % PLOTTE DELER AV STRMMEN #2
% % 1000 points = 6 uker
% 
% X_deep0 = [Xs(1000:2000,1) Xs(1000:2000,14:18)]; % wind 150 175 200 250 300
% 
% figure
% scatter3(X_deep0(:,1),X_deep0(:,4),X_deep0(:,6));
% axis([0 1 0 .05 0 .05])
% xlabel('wind')
% ylabel('200')
% zlabel('300')
% 
% X_deep0_dir = [Xd(1000:2000,1) Xd(1000:2000,14:18)]; % wind 150 175 200 250 300
% 
% figure
% scatter3(X_deep0_dir(:,1),X_deep0_dir(:,4),X_deep0_dir(:,6));
% %axis([0 360 0 360 0 360])
% xlabel('wind')
% ylabel('200')
% zlabel('300')
% 
% 
% % PLOTTE DELER AV STRMMEN #3
% % 1000 points = 6 uker
% 
% X_deep0 = [Xs(4000:5000,1) Xs(4000:5000,14:18)]; % wind 150 175 200 250 300
% 
% figure
% scatter3(X_deep0(:,1),X_deep0(:,4),X_deep0(:,6));
% axis([0 1 0 .05 0 .05])
% xlabel('wind')
% ylabel('200')
% zlabel('300')
% 
% X_deep0_dir = [Xd(4000:5000,1) Xd(4000:5000,14:18)]; % wind 150 175 200 250 300
% 
% figure
% scatter3(X_deep0_dir(:,1),X_deep0_dir(:,4),X_deep0_dir(:,6));
% %axis([0 360 0 360 0 360])
% xlabel('wind')
% ylabel('200')
% zlabel('300')


%% PCA ANALYSIS WIND AND THE DEPTHS ON THEIR OWN

% PCA ANALYSIS WIND AND CURRENT through depth

% [coeff,score,latent,tsquared,explained,mu] = pca(Xs(:,1));



%% PCA 2D-HORIZONTALLY
% depthSH
% depthDH

[coeffSH,scoreSH,latentSH,tsquaredSH,explainedSH,muSH] = pca(X_depthSH);
[coeffDH,scoreDH,latentDH,tsquaredDH,explainedDH,muDH] = pca(X_depthDH);

%%
figure
biplot(coeffSH(:,1:2),'scores',scoreSH(:,1:2),'varlabels',{'0','N10','E10','S10','W10'});

figure
scatter3(scoreSH(:,1),scoreSH(:,2),scoreSH(:,3));
axis equal
xlabel('1st PC')
ylabel('2st PC')
zlabel('3st PC')

figure
plot(explainedSH)
xlabel('number of components included')
ylabel('% variance explained')
grid on

%%
set(0, 'defaultTextFontSize',14)
figure
biplot(coeffDH(:,1:3),'scores',scoreDH(:,1:3),'varlabels',{'0','N10','E10','S10','W10'});
xlabel('PC1');
ylabel('PC2');
zlabel('PC3');

%%
figure
scatter3(scoreDH(:,1),scoreDH(:,2),scoreDH(:,3));
axis equal
xlabel('1st PC')
ylabel('2st PC')
zlabel('3st PC')

figure
plot(explainedDH)
xlabel('number of components included')
ylabel('%')
title('Variance explained in each PC out of total variance')
xticks([0 1 2 3 4 5])
grid on

%% prver  rekonstruere med PC1 og PC2

% reconstruction = score*coeff'?
rec = scoreSH*coeffSH' + repmat(muSH,length(X_depthSH),1);
error = sum((rec-X_depthSH).^2);%error = sum((rec-X).^2);

approxRank1 = scoreSH(:,1)*coeffSH(:,1)'+repmat(muSH,length(X_depthSH),1);
approxRank2 = scoreSH(:,1:2)*coeffSH(:,1:2)'+repmat(muSH,length(X_depthSH),1);
approxRank3 = scoreSH(:,1:3)*coeffSH(:,1:3)'+repmat(muSH,length(X_depthSH),1);
approxRank4 = scoreSH(:,1:4)*coeffSH(:,1:4)'+repmat(muSH,length(X_depthSH),1);

% error with different ranks
errorR2 = sum((approxRank2-X_depthSH).^2);
errorR3 = sum((approxRank3-X_depthSH).^2);
errorR4 = sum((approxRank4-X_depthSH).^2);

figure % reconstruction rank 2 pga variance explained
title('Reconstruction rank 1')
for k=1:5 
    subplot(3,2,k);
    hold on; grid on;
    plot(approxRank1(:,k),X_depthSH(:,k),'mx');
    %plot(approxRank1(:,k),X(:,k),'rx');
    plot([-5 5],[-5 5],'b');
    %xlim([-2 2]);
    %xlim([-2 2]);
    a = {'origin' 'N10' 'E10' 'S10' 'W10'};
    title(['Current at ' a{k}]);
end
%saveas(gcf,'reconstrR1_04_2.png')

figure % reconstruction rank 2 pga variance explained
title('Reconstruction rank 2')
for k=1:5 
    subplot(3,2,k);
    hold on; grid on;
    plot(approxRank2(:,k),X_depthSH(:,k),'mx');
    %plot(approxRank1(:,k),X(:,k),'rx');
    plot([-5 5],[-5 5],'b');
    %xlim([-2 2]);
    %xlim([-2 2]);
    a = {'origin' 'N10' 'E10' 'S10' 'W10'};
    title(['Current at ' a{k}]);
end
%saveas(gcf,'reconstrR2_04_2.png')

figure % reconstruction rank 3 for  se forskjellen
title('Reconstruction rank 3')
for k=1:5
    subplot(3,2,k);
    hold on; grid on;
    plot(approxRank3(:,k),X_depthSH(:,k),'mx');
    %plot(approxRank2(:,k),X(:,k),'rx');
    plot([-5 5],[-5 5],'b');
    %xlim([-2 2]);
    %xlim([-2 2]);
    a = {'origin' 'N10' 'E10' 'S10' 'W10'};
    title(['Current at ' a{k}]);
end
%saveas(gcf,'reconstrR3_04_2.png')

figure % reconstruction rank 3 for  se forskjellen
title('Reconstruction rank 4')
for k=1:5
    subplot(3,2,k);
    hold on; grid on;
    plot(approxRank4(:,k),X_depthSH(:,k),'mx');
    %plot(approxRank2(:,k),X(:,k),'rx');
    plot([-5 5],[-5 5],'b');
    %xlim([-2 2]);
    %xlim([-2 2]);
    a = {'origin' 'N10' 'E10' 'S10' 'W10'};
    title(['Current at ' a{k}]);
end
%saveas(gcf,'reconstrR4_04_2.png')

errorX = [1 2 3 4 5];

%%
set(0,'defaultAxesFontSize',14)
set(0,'DefaultLineLineWidth', 1.5);
set(0,'DefaultAxesXGrid','on','DefaultAxesYGrid','on');
set(0,'DefaultLineMarkerSize', 8);

figure
plot(errorX,errorR2,'r*-',errorX,errorR3,'g*-',errorX,errorR4,'m*-',errorX,error,'b*-')  % for hver kolonne
l = legend({'Rank 2','Rank 3','Rank 4','Rank 5'},'location','N'); %'northwest' for ikke-squared
l = set(l,'Fontsize',15);
xticklabels({'origin','N10','E10','S10','W10'})
xlabel('Variables')
ylabel('Error squared')
title('Error')
xticks([1 2 3 4 5])
grid on

