close all 
clear all

deg2rad = pi/180;

%% Explore data and extend PCA analysis ...
% wind data
load dataWind19902000.mat

windS = dataWind19902000(:,5);
windD = dataWind19902000(:,6);   % gikk for wd over Mdir

sU_dir = windD;
neste = 3*(1:(length(sU_dir)));
neste2 = 3:neste(end);

eU_dir = interp1(neste,sU_dir,neste2)'; % mangler de to siste pnts, m...
%ekstrapolere - nei, kutter heller punkt i strmmen

% endre retningen p vinden som er 180 i forskjell fra strmmen
for n = 1:length(eU_dir)
    eU_dir(n,1) = eU_dir(n,1) + 180;
    if eU_dir(n,1) > 360
        eU_dir(n,1) = eU_dir(n,1) - 360;
    end
end
   
%
sU_stre = windS;
neste = 3*(1:(length(sU_stre)));
neste2 = 3:neste(end);

eU_stre = interp1(neste,sU_stre,neste2)'; % mangler de to siste pnts, m...
%ekstrapolere - nei, kutter heller punkt i strmmen

windD = eU_dir;
windS = eU_stre;


% current data
load dataCurr19902000.mat

 S0  = dataCurr19902000(1:96430,5);
 D0  = dataCurr19902000(1:96430,6);
 S10 = dataCurr19902000(1:96430,7);
 D10 = dataCurr19902000(1:96430,8);
 S20 = dataCurr19902000(1:96430,9);
 D20 = dataCurr19902000(1:96430,10);
 S30 = dataCurr19902000(1:96430,11);
 D30 = dataCurr19902000(1:96430,12);
 S40 = dataCurr19902000(1:96430,13);
 D40 = dataCurr19902000(1:96430,14);
 S50 = dataCurr19902000(1:96430,15);
 D50 = dataCurr19902000(1:96430,16);
 S60 = dataCurr19902000(1:96430,17);
 D60 = dataCurr19902000(1:96430,18);
 S70 = dataCurr19902000(1:96430,19);
 D70 = dataCurr19902000(1:96430,20);
 S80 = dataCurr19902000(1:96430,21);
 D80 = dataCurr19902000(1:96430,22);
 S90 = dataCurr19902000(1:96430,23);
 D90 = dataCurr19902000(1:96430,24);
S100 = dataCurr19902000(1:96430,25);
D100 = dataCurr19902000(1:96430,26);
S125 = dataCurr19902000(1:96430,27);
D125 = dataCurr19902000(1:96430,28);
S150 = dataCurr19902000(1:96430,29);
D150 = dataCurr19902000(1:96430,30);
S175 = dataCurr19902000(1:96430,31);
D175 = dataCurr19902000(1:96430,32);
S200 = dataCurr19902000(1:96430,33);
D200 = dataCurr19902000(1:96430,34);
S250 = dataCurr19902000(1:96430,35);
D250 = dataCurr19902000(1:96430,36);
S300 = dataCurr19902000(1:96430,37);
D300 = dataCurr19902000(1:96430,38);

% More points, extreme values N-S-W-E






%%
% strength
X_s = [windS*100 S0 S10 S20 S30 S40 S50 S60 S70 S80 S90 S100...
    S125 S150 S175 S200 S250 S300]; % w:m/s, c:cm/s => w*100

%normalizing and rescaling
X_S = normalize(X_s,'range');
X_S = rescale(X_s,0,1); %bytte til range 0 til 1 (rar med -1 til 1 => pga neg?)

% direction
X_d = [windD D0 D10 D20 D30 D40 D50 D60 D70 D80 D90 D100...
    D125 D150 D175 D200 D250 D300];

% fourier transform?
Fs = 96430/(365*10);     % punkter delt p dager med sampling (hver time ett eller annet sted)



%% dekomponerer vektoren i x og y
Xd = X_d*deg2rad;
Xs = X_S;

[xvel,yvel] = pol2cart(Xd,Xs);

% p2 = atan2(yvel,xvel); %skulle teste, men ble ikke heeelt rett. Bruk cart2pol evt

figure
plot(xvel(:,:),yvel(:,:),'*','MarkerSize',5)
grid on
hold on
%plot(xvel(:,1),yvel(:,1),'*')


%% plotting
set(0,'DefaultLineLineWidth', 1.5);
set(0,'DefaultAxesXGrid','on','DefaultAxesYGrid','on');
set(0,'DefaultLineMarkerSize', 8);
% set(0,'DefaultAxesMarkerSize',8);

% t = linspace(1,96432,96432)';
% 
% figure
% plot(t(1:2000,:),X_S(1:2000,1), t(1:2000,:),X_S(1:2000,2));
% grid on
% 
% % t(1:500,:),X(1:500,1),t(1:500,:),X(1:500,2)
% 
% figure
% plot(t(1:2000,:),X_d(1:2000,1), t(1:2000,:),X_d(1:2000,2));
% grid on


%% Fourier analysis

% FourAna = fftn(X_d());
% LengthSignal = 3600; % 1 hour signal
% 
% %P2 = abs(FourAna/LengthSignal);
% %P1 = P2(1,LengthSignal/2+1);
% %P1(2:end-1) = 2*P1(2:end-1);
% 
% figure
% plot(abs(FourAna))
% grid on

%% PCA analyse

% [coeff,score,latent,tsquared,explained,mu] = pca(X_S);   

%% PLSR prep (sette opp matriser)

% flip array up down: B = flipud(A)

% t0 = [xvel()];
% t1 = [];

% X-matrise for januar 1990
X = [xvel(1:744,2)  yvel(1:744,2)  xvel(1:744,3)  yvel(1:744,3)  xvel(1:744,4)  yvel(1:744,4)...
     xvel(1:744,5)  yvel(1:744,5)  xvel(1:744,6)  yvel(1:744,6)  xvel(1:744,7)  yvel(1:744,7)...
     xvel(1:744,8)  yvel(1:744,8)  xvel(1:744,9)  yvel(1:744,9)  xvel(1:744,10) yvel(1:744,10)...
     xvel(1:744,11) yvel(1:744,11) xvel(1:744,12) yvel(1:744,12) xvel(1:744,13) yvel(1:744,13)...
     xvel(1:744,14) yvel(1:744,14) xvel(1:744,15) yvel(1:744,15) xvel(1:744,16) yvel(1:744,16)...
     xvel(1:744,17) yvel(1:744,17)];

% Y-matrise for januar 1991
Y = [xvel(8760:9503,2)  yvel(8760:9503,2)  xvel(8760:9503,3)  yvel(8760:9503,3)  xvel(8760:9503,4)  yvel(8760:9503,4)...
     xvel(8760:9503,5)  yvel(8760:9503,5)  xvel(8760:9503,6)  yvel(8760:9503,6)  xvel(8760:9503,7)  yvel(8760:9503,7)...
     xvel(8760:9503,8)  yvel(8760:9503,8)  xvel(8760:9503,9)  yvel(8760:9503,9)  xvel(8760:9503,10) yvel(8760:9503,10)...
     xvel(8760:9503,11) yvel(8760:9503,11) xvel(8760:9503,12) yvel(8760:9503,12) xvel(8760:9503,13) yvel(8760:9503,13)...
     xvel(8760:9503,14) yvel(8760:9503,14) xvel(8760:9503,15) yvel(8760:9503,15) xvel(8760:9503,16) yvel(8760:9503,16)...
     xvel(8760:9503,17) yvel(8760:9503,17)];

% X1 = [xvel(10,1) yvel(10,1) xvel(10,2) yvel(10,2) xvel(10,3) yvel(10,3);
%      xvel(9,1)  yvel(9,1)  xvel(9,2)  yvel(9,2)  xvel(9,3)  yvel(9,3);
%      xvel(8,1)  yvel(8,1)  xvel(8,2)  yvel(8,2)  xvel(8,3)  yvel(8,3);
%      xvel(7,1)  yvel(7,1)  xvel(7,2)  yvel(7,2)  xvel(7,3)  yvel(7,3);
%      xvel(6,1)  yvel(6,1)  xvel(6,2)  yvel(6,2)  xvel(6,3)  yvel(6,3);
%      xvel(5,1)  yvel(5,1)  xvel(5,2)  yvel(5,2)  xvel(5,3)  yvel(5,3);
%      xvel(4,1)  yvel(4,1)  xvel(4,2)  yvel(4,2)  xvel(4,3)  yvel(4,3)]; % tn tn-1...

% X = [xvel(4:100,1) yvel(4:100,1) xvel(4:100,2) yvel(4:100,2) xvel(4:100,3) yvel(4:100,3)];
% X = flipud(X)';

% Y = [xvel(4,1) yvel(4,1) xvel(4,2) yvel(4,2) xvel(4,3) yvel(4,3)]'; % tn+1
% Y = [xvel(101:120,1) yvel(101:120,1) xvel(101:120,2) yvel(101:120,2) ...
%                                      xvel(101:120,3) yvel(101:120,3)]'; % tn+1

ncomp = 20;

[XL,YL,XS,YS,BETA,PCTvar,MSE,stats] = plsregress(X,Y,ncomp);
% [XL10,YL10,XS10,YS10,BETAPLS10,PCTvar10,MSE10,stats10] = plsregress(X,Y,ncomp);

figure
plot(1:ncomp,cumsum(100*PCTvar(2,:)),'-bo');
xlabel('Number of PLS components');
ylabel('Cumulative percent variance explained in Y');
grid on

[n,p] = size(X);

% Compute fitted response values for 2-comp model and display residuals (stem)

yFit = [ones(size(X,1),1) X]*BETA;
residuals = Y - yFit;
figure
stem(residuals)
xlabel('Observation');
ylabel('Residual');

% figure
% percResid = (residuals/Y)*100;
% plot(percResid)

% PCR vha PCA

[PCAcoeff,PCAscore,PCAlatent,PCAtsq,PCAexplained] = pca(X,'Economy',false); % loading, score, var, tsquared, explained, mu
figure
plot(1:ncomp,cumsum(PCAexplained(1:ncomp,1)),'-mo')
xlabel('Number of PCA components');
ylabel('Percent variance explained in Y');

betaPCR = regress(Y(:,1)-mean(Y(:,1)),PCAscore(:,1:3));
% transform to regression coeffs for original uncentered variables
betaPCR = PCAcoeff(:,1:3)*betaPCR;
betaPCR = [mean(Y(:,1))-mean(X)*betaPCR;betaPCR];
yfitPCR = [ones(n,1) X]*betaPCR;


% plotiing fitted vs observed response to compare fits with PLSR and PCR
figure
plot(Y,yFit,'bo',Y,yfitPCR,'m^','MarkerSize',4);
xlabel('Observed response');
ylabel('Fitted response');
legend({'PLSR with 20 components' 'PCR with 20 components'},'location','NW');

% r-squared-verdi? M da skrive om i teori! (another way to compare the predictive power between the two models)

% better fitting with more components (nops, de mener mer predictors (flere PCs))




